dirs.home='/Users/wkerr/Documents/EMU/CI/MedsResponse/';
dirs.data=[dirs.home 'MedsResponse_Amalgum2_DeID.csv'];
dirs.lit =[dirs.home 'Meds_TrialsResults.csv'];
dirs.medsmatch=[dirs.home 'Meds_MatchResults.csv'];
dirs.dur =[dirs.home 'MedsResponse_DurationInfo_DeID.csv'];
dirs.table1=[dirs.home 'MedsResponse_Table1.csv'];

%% Load Literature results
fid=fopen(dirs.lit,'r');
h=textscan(fid,'%s %f %f %f %f %f %f %f %f %f %s %s %s','Delimiter',',','Headerlines',2);
fclose(fid);
n.studies=length(h{1});
counts=zeros(n.studies,3);
counts(:,1)=h{2};
counts(:,2)=h{3};
counts(:,3)=h{4};
perc50=zeros(n.studies,2);
perc50(:,1)=h{7};
perc50(:,2)=h{8};
litmeds=h{1};

litperc50=[sum(counts(:,2).*perc50(:,1))/sum(counts(:,2)),sum(counts(:,3).*perc50(:,2))/sum(counts(:,3))];
litcounts=sum(counts);

%% Load Data
fid=fopen(dirs.data,'r');
d=textscan(fid,'%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s','Delimiter',',','Headerlines',0);
fclose(fid);
n.lines=length(d{1});
n.col=length(d);

%% Parse Data

% Age and Gender
ix.mrn=2;
ix.age=5;
ix.gender=6;
ix.AoO=8;
cnt.sub=0;
ix.sub=[];
data.demo=zeros(n.lines,3);
data.mrns=zeros(n.lines,1);
for ind=1:n.lines
    if ~isempty(d{ix.age}{ind}) && ~strcmp(d{ix.age}{ind},'Age')
        ix.sub=[ix.sub, ind];
        cnt.sub=cnt.sub+1;
        data.mrns(cnt.sub,1)=str2num(d{ix.mrn}{ind});
        data.demo(cnt.sub,1)=str2num(d{ix.age}{ind});
        data.demo(cnt.sub,2)=strcmp(d{ix.gender}{ind},'F');
        if ~isempty(str2num(d{ix.AoO}{ind}))
            data.demo(cnt.sub,3)=str2num(d{ix.AoO}{ind});
        end
    end
end
data.demo=data.demo(1:cnt.sub,:);

% Find Exposures
coders=unique(d{1});
n.coders=length(coders);
ix.exp=cell(n.coders,1);
cnt.took=0;
data.resp=zeros(cnt.sub,100,3);
% Took
% Response
% Duration
data.med=cell(cnt.sub,100);
data.resp(:,:,2:3)=-1;
cnt.med =zeros(cnt.sub,1);
for cnd=1:n.coders
    if ~isempty(coders{cnd})
        ix.coder=find(strcmp(d{1},coders{cnd}));
        ix.exp{cnd}  =[];
        for jnd=1:n.col
            if strcmp(d{jnd}{ix.coder(2)},'Exposed to Med')
                ix.exp{cnd}=[ix.exp{cnd}, jnd];
                ix.took=find(strcmp(d{jnd}(ix.coder),'1'));
                cnt.took=cnt.took+length(ix.took);
                for knd=1:length(ix.took)
                    iy.sub=find(ix.sub==ix.coder(ix.took(knd)));
                    cnt.med(iy.sub)=cnt.med(iy.sub)+1;
                    data.med{iy.sub,cnt.med(iy.sub)}=d{jnd}{ix.coder(1)};
                    data.resp(iy.sub,cnt.med(iy.sub),1)=1;
                    if ~isempty(str2num(d{jnd+1}{ix.coder(ix.took(knd))}))
                        data.resp(iy.sub,cnt.med(iy.sub),2)=str2num(d{jnd+1}{ix.coder(ix.took(knd))});
                    end
                    if ~isempty(str2num(d{jnd+2}{ix.coder(ix.took(knd))}))
                        data.resp(iy.sub,cnt.med(iy.sub),3)=str2num(d{jnd+2}{ix.coder(ix.took(knd))});
                    end
                end
            end
        end
    end
end
data.resp=data.resp(:,1:max(cnt.med),:);
data.med =data.med(:,1:max(cnt.med));

% Clean Response columns
[iy.percx iy.percy]=find(data.resp(:,:,2)<=1 & data.resp(:,:,2)>0);
data.resp(iy.percx,iy.percy,2)=data.resp(iy.percx,iy.percy,2)*100;
[iy.percx iy.percy]=find(data.resp(:,:,2)>100);
data.resp(iy.percx,iy.percy,2)=data.resp(iy.percx,iy.percy,2)/100;


%% Summary Statistics
cnt.tookmeds=sum(sum(data.resp(:,:,1),2)>0);
% For all meds
cnt.resp=sum(sum(data.resp(:,:,2)>0));
cnt.resp50=sum(sum(data.resp(:,:,2)>=50));
cnt.resp100=sum(sum(data.resp(:,:,2)>=100));
cnt.know=sum(sum(data.resp(:,:,2)>-1));
percresp=cnt.resp/cnt.know;
percresp50=cnt.resp50/cnt.know;

cnt.knowmeds=sum(data.resp(:,:,2)>-1,2);
ix.knowmeds=find(cnt.knowmeds>0);
data.avgmeds=mean(cnt.knowmeds(ix.knowmeds));
data.sdmeds =std(cnt.knowmeds(ix.knowmeds));
data.maxmeds=max(cnt.knowmeds(ix.knowmeds));
cnt.ptsknowASM=sum(cnt.knowmeds>0);

[ix.respx ix.respy]=find(data.resp(:,:,2)>0);
resplevs=zeros(length(ix.respx),1);
for ind=1:length(ix.respx)
    resplevs(ind)=data.resp(ix.respx(ind),ix.respy(ind),2);
end
medianresp=median(resplevs);

% By specific med
meds=cell(100,1);
cnt.meds=0;
for ind=1:cnt.sub
    for jnd=1:max(cnt.med)
        if ~isempty(data.med{ind,jnd})
            matchexists=0;
            if cnt.meds % see if unique
                for knd=1:cnt.meds
                    if strcmp(data.med(ind,jnd),meds(knd))
                        matchexists=1;
                    end
                end
            end
            if ~matchexists
                cnt.meds=cnt.meds+1;
                meds(cnt.meds)=data.med(ind,jnd);
            end
        end
    end
end
meds=meds(1:cnt.meds);
meds=sort(meds);
meds=meds(end:-1:1);

bymed.cntresp   =zeros(cnt.meds,1);
bymed.cntresp50 =zeros(cnt.meds,1);
bymed.cntknow   =zeros(cnt.meds,1);
bymed.cnttook   =zeros(cnt.meds,1);
for mnd=1:cnt.meds
    for ind=1:cnt.sub
        for jnd=1:max(cnt.med)
            if strcmp(meds(mnd),data.med(ind,jnd))
                bymed.cnttook(mnd)  =bymed.cnttook(mnd)  +data.resp(ind,jnd,1);
                bymed.cntknow(mnd)  =bymed.cntknow(mnd)  +1*(data.resp(ind,jnd,2)>-1);
                bymed.cntresp(mnd)  =bymed.cntresp(mnd)  +1*(data.resp(ind,jnd,2)>0);
                bymed.cntresp50(mnd)=bymed.cntresp50(mnd)+1*(data.resp(ind,jnd,2)>=50);
            end
        end
    end
end
% fixing duplictes
ix.diazepam=find(strcmp(meds,'Diazepam') | strcmp(meds,'Valium/Diazepam') | strcmp(meds,'Valium (Diazepam) '));
bymed.cntresp(ix.diazepam)=sum(bymed.cntresp(ix.diazepam));
bymed.cntresp50(ix.diazepam)=sum(bymed.cntresp50(ix.diazepam));
bymed.cntknow(ix.diazepam)=sum(bymed.cntknow(ix.diazepam));
bymed.cnttook(ix.diazepam)=sum(bymed.cnttook(ix.diazepam));

ix.ativan  =find(strcmp(meds,'Ativan') | strcmp(meds,'Ativan/Lorazepam '));
bymed.cntresp(ix.ativan)=sum(bymed.cntresp(ix.ativan));
bymed.cntresp50(ix.ativan)=sum(bymed.cntresp50(ix.ativan));
bymed.cntknow(ix.ativan)=sum(bymed.cntknow(ix.ativan));
bymed.cnttook(ix.ativan)=sum(bymed.cnttook(ix.ativan));

ix.carba   =find(strcmp(meds,'Carbamazepine/Tegretol/Carbatrol') | strcmp(meds,'Carbamazepine/Tegretol'));
bymed.cntresp(ix.carba)=sum(bymed.cntresp(ix.carba));
bymed.cntresp50(ix.carba)=sum(bymed.cntresp50(ix.carba));
bymed.cntknow(ix.carba)=sum(bymed.cntknow(ix.carba));
bymed.cnttook(ix.carba)=sum(bymed.cnttook(ix.carba));

bymed.percresp  =bymed.cntresp./bymed.cntknow;
bymed.percresp50=bymed.cntresp50./bymed.cntknow;

%% Plot Results
ix.hazdata=find(bymed.cntknow>1 & ~strcmp(meds,'VNS'));
ix.hazdata=setdiff(ix.hazdata,ix.diazepam(2:end));
ix.hazdata=setdiff(ix.hazdata,ix.ativan(2));
ix.hazdata=setdiff(ix.hazdata,ix.carba(2));
ix.hazdata=setdiff(ix.hazdata,24); % ES Surgery
% figure
% bar1=barh([bymed.percresp(ix.hazdata); percresp],'BarWidth',1);
% xlabel('Patients reporting reduction in seizure frequency (%)');
% set(gca,'ylim',[0.5 length(ix.hazdata)+1.5],'ytick',1:length(ix.hazdata)+1,'yticklabel',{meds{ix.hazdata},'All'});
% Acclabs={'0%','10%','20%','30%','40%','50%','60%','70%','80%','90%','100%'};
% set(gca,'xlim',[0 1],'xtick',0:.1:1,'xticklabel',Acclabs);
% set(bar1(1),'FaceColor',[0.6 0.6 0.6]);
% hold on
% for ind=1:length(ix.hazdata)
%     if bymed.percresp(ix.hazdata(ind))==0
%         bymed.percresp(ix.hazdata(ind))=1/2/bymed.cntknow(ix.hazdata(ind));
%     end
%     LB=bymed.percresp(ix.hazdata(ind))-binoinv(0.025,bymed.cntknow(ix.hazdata(ind)),bymed.percresp(ix.hazdata(ind)))/bymed.cntknow(ix.hazdata(ind));
%     UB=binoinv(0.975,bymed.cntknow(ix.hazdata(ind)),bymed.percresp(ix.hazdata(ind)))/bymed.cntknow(ix.hazdata(ind))-bymed.percresp(ix.hazdata(ind));
%     eb=herrorbar(bymed.percresp(ix.hazdata(ind)),ind,LB,UB);
%     set(eb(1),'color','black','LineWidth',3);
%     removeErrorBarEnds(eb);
% end
% LB=percresp-binoinv(0.025,cnt.know,percresp)/cnt.know;
% UB=binoinv(0.975,cnt.know,percresp)/cnt.know-percresp;
% eb=herrorbar(percresp,ind+1,LB,UB);
% set(eb(1),'color','black','LineWidth',3);
% removeErrorBarEnds(eb);
% hold off

figure
bar1=barh([bymed.percresp50(ix.hazdata); percresp50],'BarWidth',1);
xlabel('Patients reporting 50% or more reduction in seizure frequency (%)');
medlabels={'Zonisamide','Valproate','Diazepam','Topiramate','Primidone','Pregabalin','Phenytoin','Phenobarbital','Oxcarbazepine','Levetiracetam','Lamotrigine','Lacosamide','Gabapentin','Clonazepam','Carbamazepine','Lorazepam','Acetazolamide','All Medications'};
medord=[1:9 16 10:15 17 18];
set(gca,'fontsize',14);
set(gca,'ylim',[0.5 length(ix.hazdata)+1.5],'ytick',1:length(ix.hazdata)+1,'yticklabel',{medlabels{medord}});
Acclabs={'0%','10%','20%','30%','40%','50%','60%','70%','80%','90%','100%'};
set(gca,'xlim',[0 1],'xtick',0:.1:1,'xticklabel',Acclabs);
set(bar1(1),'FaceColor',[0.6 0.6 0.6]);
hold on
pairwise=zeros(length(ix.hazdata));
minp=1;
for ind=1:length(ix.hazdata)
    if ind<length(ix.hazdata)
        for jnd=ind+1:length(ix.hazdata)
            [tmpp.h tmpp.p tmpp.stats]=fishertest([bymed.cntresp50(ind),bymed.cntresp50(jnd);bymed.cnttook(ind)-bymed.cntresp50(ind),bymed.cnttook(jnd)-bymed.cntresp50(jnd)]);
            if tmpp.p<minp
                minp=tmpp.p;
            end
        end
    end
    if bymed.percresp50(ix.hazdata(ind))==0
        bymed.percresp50(ix.hazdata(ind))=1/2/bymed.cntknow(ix.hazdata(ind));
    end
    LB=bymed.percresp50(ix.hazdata(ind))-binoinv(0.025,bymed.cntknow(ix.hazdata(ind)),bymed.percresp50(ix.hazdata(ind)))/bymed.cntknow(ix.hazdata(ind));
    UB=binoinv(0.975,bymed.cntknow(ix.hazdata(ind)),bymed.percresp50(ix.hazdata(ind)))/bymed.cntknow(ix.hazdata(ind))-bymed.percresp50(ix.hazdata(ind));
    eb=errbar(bymed.percresp50(ix.hazdata(ind)),ind,LB,UB,'horiz');
    set(eb(1),'color','black','LineWidth',3);
    removeErrorBarEnds(eb);
end
LB=percresp50-binoinv(0.025,cnt.know,percresp50)/cnt.know;
UB=binoinv(0.975,cnt.know,percresp50)/cnt.know-percresp50;
eb=errbar(percresp50,ind+1,LB,UB,'horiz');
set(eb(1),'color','black','LineWidth',3);
removeErrorBarEnds(eb);
hold off

%% Tests of Significance

% All Placebo vs PNES
fishmx=zeros(2,2);
fishmx(1,1)=round(litperc50(2)*litcounts(3)/100);
fishmx(2,1)=litcounts(3)-fishmx(1,1);
fishmx(2,2)=cnt.know-cnt.resp50;
fishmx(1,2)=cnt.resp50;

% All Active vs PNES
fishmx2=zeros(2,2);
fishmx2(1,1)=round(litperc50(1)*litcounts(2)/100);
fishmx2(2,1)=litcounts(2)-fishmx2(1,1);
fishmx2(2,2)=cnt.know-cnt.resp50;
fishmx2(1,2)=cnt.resp50;

% Match individual meds
n.meds=length(meds);
n.litmeds=length(litmeds);
ix.litmatch=zeros(n.litmeds,1);
ix.medmatch=zeros(n.meds,1);
for mnd=1:n.litmeds
    lenlitmed=length(litmeds{mnd});
    for dnd=1:n.meds
        lenmed=length(meds{dnd});
        if lenmed>=lenlitmed
            for jnd=1:(lenmed-lenlitmed+1)
                if strcmp(litmeds{mnd},meds{dnd}(jnd:(jnd+lenlitmed-1)))
                    ix.litmatch(mnd)=dnd;
                    ix.medmatch(dnd)=mnd;
                end
            end
        end
    end
end

ix.medspluslit=intersect(ix.hazdata,ix.litmatch);
n.medspluslit=length(ix.medspluslit);
countsmatch=zeros(n.medspluslit,3,2);
% Placebo
%   Count Respond
%   Count Don't Respond
% Active
% Observed
for ind=1:n.medspluslit
    iy=find(ix.litmatch==ix.medspluslit(ind));
    tmp=zeros(length(iy),2);
    for jnd=1:length(iy)
        tmp(jnd,1)=counts(iy(jnd),2);
        tmp(jnd,2)=counts(iy(jnd),3);
    end
    countsmatch(ind,1,1)=round(sum(tmp(:,2).*perc50(iy,2)/100));
    countsmatch(ind,1,2)=sum(tmp(:,2))-countsmatch(ind,1,1);
    countsmatch(ind,2,1)=round(sum(tmp(:,1).*perc50(iy,1)/100));
    countsmatch(ind,2,2)=sum(tmp(:,1))-countsmatch(ind,2,1);
    countsmatch(ind,3,1)=bymed.cntresp50(ix.medspluslit(ind));
    countsmatch(ind,3,2)=bymed.cntknow(ix.medspluslit(ind))-countsmatch(ind,3,1);
end

dirs.medsmatch=[dirs.home 'Meds_MatchResults.csv'];
fid=fopen(dirs.medsmatch,'w');
fprintf(fid,'Med,Plac-R,Plac-DR,Act-R,Act-DR,Obs-R,Obs-DR,\n');
for fnd=1:n.medspluslit
    fprintf(fid,[meds{ix.medspluslit(fnd)} ',']);
    for ind=1:3
        for jnd=1:2
            fprintf(fid,[num2str(countsmatch(fnd,ind,jnd)) ',']);
        end
    end
    fprintf(fid,'\n');
end
fclose(fid);

%% Plot Comparison Results           
data.comparison=zeros(n.medspluslit+1,3);
data.comparison(1:n.medspluslit,:)=countsmatch(:,:,1)./sum(countsmatch,3)*100;
data.comparison(end,3)=percresp50*100;
data.comparison(end,1:2)=litperc50([2 1]);
nn=zeros(n.medspluslit+1,3);
pp=nn;

figure
bar1=barh(data.comparison,'BarWidth',1);
xlabel('Patients reporting 50% or more reduction in seizure frequency (%)');
set(gca,'ylim',[0.5 n.medspluslit+1.5],'ytick',1:n.medspluslit+1,'yticklabel',{meds{ix.medspluslit},'All'});
Acclabs={'0%','10%','20%','30%','40%','50%','60%','70%','80%','90%','100%'};
set(gca,'xlim',[0 80],'xtick',0:10:100,'xticklabel',Acclabs);
set(bar1(1),'DisplayName','Placebo');
set(bar1(2),'DisplayName','Active');
set(bar1(3),'DisplayName','PNES','FaceColor',[0.6 0.6 0.6]);
legend1 = legend(gca,'show');
offset=[-.22 0 0.22];
hold on
for ind=1:n.medspluslit
    for jnd=1:3
        nn(ind,jnd)=sum(countsmatch(ind,jnd,:),3);
        pp(ind,jnd)=data.comparison(ind,jnd)/100;
        LB=pp(ind,jnd)-binoinv(0.025,nn(ind,jnd),pp(ind,jnd))/nn(ind,jnd);
        UB=binoinv(0.975,nn(ind,jnd),pp(ind,jnd))/nn(ind,jnd)-pp(ind,jnd);
%         eb=herrorbar(data.comparison(ind,jnd),ind+offset(jnd),LB*100,UB*100);
%         set(eb(1),'color','black','LineWidth',3);
%         removeErrorBarEnds(eb);
    end
end
cnt.plot=1;
for jnd=[2 1]
    nn(n.medspluslit+1,cnt.plot)=litcounts(1+jnd);
    pp(n.medspluslit+1,cnt.plot)=litperc50(jnd)/100;
    LB=pp(n.medspluslit+1,cnt.plot)-binoinv(0.025,nn(n.medspluslit+1,cnt.plot),pp(n.medspluslit+1,cnt.plot))/nn(n.medspluslit+1,cnt.plot);
    UB=binoinv(0.975,nn(n.medspluslit+1,cnt.plot),pp(n.medspluslit+1,cnt.plot))/nn(n.medspluslit+1,cnt.plot)-pp(n.medspluslit+1,cnt.plot);
%     eb=herrorbar(pp(n.medspluslit+1,cnt.plot)*100,n.medspluslit+1+offset(cnt.plot),LB*100,UB*100);
%     set(eb(1),'color','black','LineWidth',3);
%     removeErrorBarEnds(eb);
    cnt.plot=cnt.plot+1;
end
nn(n.medspluslit+1,3)=cnt.know;
pp(n.medspluslit+1,3)=percresp50;
LB=pp(n.medspluslit+1,3)-binoinv(0.025,nn(n.medspluslit+1,3),pp(n.medspluslit+1,3))/nn(n.medspluslit+1,3);
UB=binoinv(0.975,nn(n.medspluslit+1,3),pp(n.medspluslit+1,3))/nn(n.medspluslit+1,3)-pp(n.medspluslit+1,3);
% eb=herrorbar(percresp50*100,n.medspluslit+1+offset(3),LB*100,UB*100);
% set(eb(1),'color','black','LineWidth',3);
% removeErrorBarEnds(eb);
hold off

%% Time of Response

[ix.timex ix.timey]=find(data.resp(:,:,3)>0);
didresp=zeros(length(ix.timex),1);
for tnd=1:length(ix.timex)
    didresp(tnd)=1*(data.resp(ix.timex(tnd),ix.timey(tnd),2)>=50);
end
n.timetick=sum(didresp);
data.timetick=zeros(n.timetick,1);
ix.timeresp=find(didresp);
for tnd=1:n.timetick
    data.timetick(tnd)=data.resp(ix.timex(ix.timeresp(tnd)),ix.timey(ix.timeresp(tnd)),3);
end
data.timetick=sort(data.timetick);
sizetick=percresp50/n.timetick;
data.percresp50time=zeros(n.timetick+1,2);
data.percresp50time(1,1)=percresp50;
data.percresp50time(1,2)=0;
for tnd=1:n.timetick
    data.percresp50time(tnd+1,1)=percresp50-sizetick*tnd;
    data.percresp50time(tnd+1,2)=data.timetick(tnd);
end
data.timemeds=cell(n.timetick,1);
for tnd=1:n.timetick
    data.timemeds{tnd}=data.med{ix.timex(ix.timeresp(tnd)),ix.timey(ix.timeresp(tnd))};
end
[data.histcnt,data.histcen]=hist(data.percresp50time(2:end,2),30);
data.histcnt=data.histcnt/sum(data.histcnt);
modelfun=@(b,S) b.*exp(-b*S);
[beta,R,J,Cov,MSE]=nlinfit(data.histcen,data.histcnt,modelfun,1);
% fittedval=beta.*exp(-beta.*data.histcen);
% figure;
% plot([data.histcnt;fittedval]');
data.exprespdur=1/beta;
data.exprespdurCI=[1/(beta+1.96*sqrt(Cov)), 1/(beta-1.96*sqrt(Cov))];

figure;
plot1=plot(data.percresp50time(:,2),data.percresp50time(:,1),'LineWidth',2,'color','black');
set(gca,'fontsize',18);
ylabel('Percent Responders');
xlabel('Duration of Response (years)');
set(gca,'ytick',0:0.05:0.35,'yticklabel',{'0%','5%','10%','15%','20%','25%','30%','35%'});

figure;
logtime=[-3 log10(data.percresp50time(2:end,2))'];
plot1=plot(logtime,data.percresp50time(:,1),'LineWidth',2,'color','black');
set(gca,'fontsize',18);
ylabel('Percent Responders');
xlabel('Duration of Response (log-scale)');
set(gca,'ytick',0:0.05:0.35,'yticklabel',{'0%','5%','10%','15%','20%','25%','30%','35%'});
set(gca,'xlim',[-3 log10(30)],'xtick',[-3 log10([1/365 1/12 1/2 1 5 10 30])],'xticklabel',{'0','1d','1mo','6mo','1y','5y','10y','30y'});

%% Duration Analysis

%Load Data
fid2=fopen(dirs.dur,'r');
q=textscan(fid2,'%f %s %f %f %f','Delimiter',',','HeaderLines',1);
fclose(fid2);

%Parse Data
ix.mrn2=1;
n.dursub=sum(q{1}>0);
data.dur=zeros(n.dursub,6);
data.mrn=zeros(n.dursub,1);
for ind=1:n.dursub
    data.dur(ind,1)=strcmp(q{2}{ind},'F');
    data.mrn(ind)  =q{ix.mrn2}(ind);
end
data.dur(:,2)=q{3}(1:n.dursub);
data.dur(:,3)=q{4}(1:n.dursub);
data.dur(:,4)=q{5}(1:n.dursub);

%Add Response Data
tmpp.dur=zeros(n.dursub,2);
tmpp.dur(:,1)=squeeze(sum(data.resp(:,:,1),2));
tmpk=(data.resp(:,:,2)>50);
tmpp.dur(:,2)=squeeze(sum(tmpk,2));

%Align Data
for ind=1:n.dursub
    imrn=find(data.mrns==data.mrn(ind));
    if length(imrn)>1
        data.dur(ind,5)=tmpp.dur(imrn(1),1);
        data.dur(ind,6)=tmpp.dur(imrn(1),2);
    else
        data.dur(ind,5)=tmpp.dur(imrn,1);
        data.dur(ind,6)=tmpp.dur(imrn,2);
    end
end

%Make the Model
ix.Durs=find(~isnan(data.dur(:,2)));
n.subdur=length(ix.Durs);
modeldata.X=data.dur(ix.Durs,[1 5 6]);
modeldata.Y=log(data.dur(ix.Durs,2));
modeldata.Yr=data.dur(ix.Durs,2);
[b0,dev0,stats0]=glmfit(ones(length(modeldata.Y),1),modeldata.Y,'normal');
[b,dev,stats]=glmfit(modeldata.X,modeldata.Y,'normal');
[br,devr,statsr]=glmfit(modeldata.X,modeldata.Yr,'normal');
data.modelsig=1-chi2cdf(dev0-dev,3);

%Summary Figure for the model
figure
% plot the raw data
sc1=scatter(modeldata.X(:,2)+rand(n.subdur,1)/2-1/4,modeldata.Y+rand(n.subdur,1)/12-1/24,20,[0.4 0.4 0.4],'filled');
set(gca,'fontsize',16);
ylabel('Diagnostic Delay');
xlabel('Number of ASM trials');
durs=[1/365 1/52 1/12 1/2 1 2 5 10 20 50];
dursl=log(durs);
set(gca,'ytick',dursl,'yticklabel',{'1d','1w','1mo','6mo','1y','2y','5y','10y','20y','50y'});
set(gca,'ylim',[min(modeldata.Y)-0.1 max(modeldata.Y)+0.1],'xlim',[-0.5 max(modeldata.X(:,2))+0.5]);
% overlay the model
n.medtr=max(modeldata.X(:,2))+1;
medtr=0:max(modeldata.X(:,2));
preddur=zeros(n.medtr,3);
[preddur(:,1),preddur(:,2),preddur(:,3)]=glmval(b,[zeros(n.medtr,1),medtr',zeros(n.medtr,1)],'identity',stats);
%yhat, 95%LB, 95%UB
hold on
pl=errbar(medtr,preddur(:,1),preddur(:,2),preddur(:,3),'LineWidth',5,'color','blue');
hold off

% sc1=scatter(modeldata.X(:,2)+rand(n.subdur,1)/2-1/4,modeldata.Yr+rand(n.subdur,1)/12-1/24,20,[0.4 0.4 0.4],'filled');
% set(gca,'fontsize',16);
% durs=[1/365 1/52 1/12 1/2 1 2 5 10 20 50];
% dursl=log(durs);
% set(gca,'ytick',durs,'yticklabel',{'1d','1w','1mo','6mo','1y','2y','5y','10y','20y','50y'});
% set(gca,'ylim',[min(modeldata.Yr)-0.1 max(modeldata.Yr)+0.1],'xlim',[-0.5 max(modeldata.X(:,2))+0.5]);
% % overlay the model
% n.medtr=max(modeldata.X(:,2))+1;
% medtr=0:max(modeldata.X(:,2));
% preddur=zeros(n.medtr,3);
% [preddur(:,1),preddur(:,2),preddur(:,3)]=glmval(br,[zeros(n.medtr,1),medtr',zeros(n.medtr,1)],'identity',statsr);
% %yhat, 95%LB, 95%UB
% hold on
% pl=errbar(medtr,preddur(:,1),preddur(:,2),preddur(:,3),'LineWidth',3,'color','blue');
% hold off

%% Calculations for Discussion point

%average if refer <=2ASM
ix.twoASM=find(modeldata.X(:,2)<=2);
data.avgtwoASM=zeros(4,1);
data.avgtwoASM(1)=mean(modeldata.Yr(ix.twoASM));
data.avgtwoASM(2)=std(modeldata.Yr(ix.twoASM))/sqrt(length(ix.twoASM));
data.avgtwoASM(3)=data.avgtwoASM(1)-1.96*data.avgtwoASM(2);
data.avgtwoASM(4)=data.avgtwoASM(1)+1.96*data.avgtwoASM(2);
data.exptwoASM=zeros(4,1);
data.exptwoASM(1)=mean(modeldata.Y(ix.twoASM));
data.exptwoASM(2)=std(modeldata.Y(ix.twoASM))/sqrt(length(ix.twoASM));
data.exptwoASM(3)=data.exptwoASM(1)-1.96*data.exptwoASM(2);
data.exptwoASM(4)=data.exptwoASM(1)+1.96*data.exptwoASM(2);
data.exptwoASM([1 3 4])=exp(1).^(data.exptwoASM([1 3 4]));

%min and max cases
ix.mindur =find(data.dur(:,2)==nanmin(data.dur(:,2)));
data.dur(ix.mindur,:)
ix.mindur2=find(data.mrns==data.mrn(ix.mindur));
% fprintf(['Min Delay ' num2str(data.mrn(ix.mindur)) ' ' 
data.demo(ix.mindur2,:)
data.mrn(ix.mindur)

ix.maxdur=find(data.dur(:,2)==nanmax(data.dur(:,2)));
data.dur(ix.maxdur,:)
ix.maxdur2=find(data.mrns==data.mrn(ix.maxdur));
data.demo(ix.maxdur2,:)
data.mrn(ix.maxdur)

%how many respond to X ASMs
tmpp.nResp=max(data.dur(:,6))+1;
data.nResp=zeros(tmpp.nResp,1);
for ind=1:max(data.dur(:,6))
    data.nResp(ind+1)=sum(data.dur(:,6)>=ind);
end

ix.resp50=find(data.dur(:,6));
data.nASMnoresp=[mean(data.dur(ix.resp50,5)) std(data.dur(ix.resp50,5))/sqrt(length(ix.resp50))];
ix.noresp50=setdiff(1:length(data.dur),ix.resp50);
data.nASMresp  =[mean(data.dur(ix.noresp50,5)) std(data.dur(ix.noresp50,5))/sqrt(length(ix.noresp50))];
[tmph, data.nASMp, tmpci, data.nASMstats]=ttest2(data.dur(ix.resp50,5),data.dur(ix.noresp50,5),'alpha',0.05,'tail','both','vartype','unequal');

%% Table 1
table1=zeros(6,5);
% Gender
table1(1,3)=mean(data.demo(:,2));
table1(1,2)=binoinv(0.025,n.dursub,table1(1,3))/n.dursub;
table1(1,4)=binoinv(0.975,n.dursub,table1(1,3))/n.dursub;
% Onset Age
ix.hazAoO=find(data.demo(:,3)>0);
table1(2,1)=min(data.demo(ix.hazAoO,3));
table1(2,5)=max(data.demo(ix.hazAoO,3));
table1(2,3)=mean(data.demo(ix.hazAoO,3));
table1(2,2)=mean(data.demo(ix.hazAoO,3))-1.96*std(data.demo(ix.hazAoO,3))/sqrt(length(ix.hazAoO));
table1(2,4)=mean(data.demo(ix.hazAoO,3))+1.96*std(data.demo(ix.hazAoO,3))/sqrt(length(ix.hazAoO));
% Assessment Age
table1(3,1)=min(data.demo(:,1));
table1(3,5)=max(data.demo(:,1));
table1(3,3)=mean(data.demo(:,1));
table1(3,2)=mean(data.demo(:,1))-1.96*std(data.demo(:,1))/sqrt(n.dursub);
table1(3,4)=mean(data.demo(:,1))+1.96*std(data.demo(:,1))/sqrt(n.dursub);
% Diagnostic Delay
table1(4,1)=exp(min(modeldata.Y));
table1(4,5)=exp(max(modeldata.Y));
table1(4,3)=exp(mean(modeldata.Y));
table1(4,2)=exp(mean(modeldata.Y)-1.96*std(modeldata.Y)/sqrt(n.subdur));
table1(4,4)=exp(mean(modeldata.Y)+1.96*std(modeldata.Y)/sqrt(n.subdur));
% ASM Trials
table1(5,1)=min(data.dur(:,5));
table1(5,5)=max(data.dur(:,5));
table1(5,3)=mean(data.dur(:,5));
table1(5,2)=mean(data.dur(:,5))-1.96*std(data.dur(:,5))/sqrt(n.dursub);
table1(5,4)=mean(data.dur(:,5))+1.96*std(data.dur(:,5))/sqrt(n.dursub);
% ASM Successes
table1(6,1)=min(data.dur(:,6));
table1(6,5)=max(data.dur(:,6));
table1(6,3)=mean(data.dur(:,6));
table1(6,2)=mean(data.dur(:,6))-1.96*std(data.dur(:,6))/sqrt(n.dursub);
table1(6,4)=mean(data.dur(:,6))+1.96*std(data.dur(:,6))/sqrt(n.dursub);

dirs.table1=[dirs.home 'MedsResponse_Table1.csv'];
fid=fopen(dirs.table1,'w');
fprintf(fid,',Percent Female,Onset Age,Assessment Age,Diagnostic Delay,ASM Trials,ASM Responses\n');
row={'Min','95 CI LB','Mean','95 CI UB','Max'};
for ind=1:5
    fprintf(fid,row{ind});
    for jnd=1:6
        fprintf(fid,[',' num2str(table1(jnd,ind))]);
    end
    fprintf(fid,'\n');
end
fclose(fid);

